select
    an.numero
    , an.nome
    , (select re1.nome from setor re1 where re1.cdsetor = an.cdsetor) as Setor_Atual
    , an.dtnascimento as data_nascimento
    , an.dtaptidao as data_aptidao   
    , ptent.data as Primeira_Tentativa
    , (((ptent.data- an.dtnascimento)/365) ||
        ' anos(s) ' ||
        (cast(((ptent.data - an.dtnascimento)/30.5) as decimal(15,0)) - (12 * ((ptent.data - an.dtnascimento)/365))) ||
        ' ms(s) ' ||
        cast((((ptent.data - an.dtnascimento) - (((ptent.data - an.dtnascimento)/365)*365) - ((((ptent.data - an.dtnascimento)/30.5) - (12 * ((ptent.data - an.dtnascimento)/365)))*30.5))) as decimal (15,0)) ||
        ' dia(s)') as Idade_Primeira_Tentativa
    , ptentp.data as Primeira_Concepcao
    , (((ptentp.data- an.dtnascimento)/365) ||
        ' anos(s) ' ||
        (cast(((ptentp.data - an.dtnascimento)/30.5) as decimal(15,0)) - (12 * ((ptentp.data - an.dtnascimento)/365))) ||
        ' ms(s) ' ||
        cast((((ptentp.data - an.dtnascimento) - (((ptentp.data - an.dtnascimento)/365)*365) - ((((ptentp.data - an.dtnascimento)/30.5) - (12 * ((ptentp.data - an.dtnascimento)/365)))*30.5))) as decimal (15,0)) ||
        ' dia(s)') as Idade_Primeira_Concepcao
 from
    animal an
    left join reproducao ptent on ptent.cdreproducao =
        (select first 1 re2.cdreproducao
            from reproducao re2
            where re2.cdanimal = an.cdanimal
                and re2.cdtiporeproducao in (1,2,3)
            order by re2.data asc)
    left join reproducao pdigp on pdigp.cdreproducao =
        (select first 1 re2.cdreproducao
            from reproducao re2
            where re2.cdanimal = an.cdanimal
                and re2.cdtiporeproducao in (4)
            order by re2.data asc)
    left join reproducao ptentp on ptentp.cdreproducao =
        (select first 1 re2.cdreproducao
            from reproducao re2
            where re2.cdanimal = an.cdanimal
                and re2.cdtiporeproducao in (1,2,3)
                and re2.data < pdigp.data
            order by re2.data desc)
    left join sp_categoriaanimal(current_date, 'cdanimal = ' || an.cdanimal) sp on 1 = 1 
where
     an.dtbaixa is null
     and an.tipoanimal = 'A'
     and an.animalrebanho = '1'
     and an.cdcategoria = '6'
     and sp.creprodutiva = 3
order by an.numordenado
  